#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */

#include <tarot.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#ifndef LOCALEDIR
#define LOCALEDIR "/usr/share/locale"
#endif /* NOT LOCALEDIR */

int
main ()
{
  static const char *example =
    "<?xml version=\"1.0\"?>"
    "<!-- tarot implements the rules of the tarot game"
    "Copyright (C) 2019  Vivien Kraus"
    ""
    "This program is free software: you can redistribute it and/or modify"
    "it under the terms of the GNU General Public License as published by"
    "the Free Software Foundation, either version 3 of the License, or (at"
    "your option) any later version."
    ""
    "This program is distributed in the hope that it will be useful, but"
    "WITHOUT ANY WARRANTY; without even the implied warranty of"
    "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU"
    "General Public License for more details."
    ""
    "You should have received a copy of the GNU General Public License"
    "along with this program.  If not, see <http://www.gnu.org/licenses/>."
    "-->"
    ""
    "<game xmlns=\"http://planete-kraus.eu/tarot\">"
    "  <setup n-players=\"5\" with-call=\"yes\"/>"
    "  <deal to=\"P5\">"
    "    <card card=\"10H\"/>"
    "    <card card=\"JH\"/>"
    "    <card card=\"CH\"/>"
    "    <card card=\"QH\"/>"
    "    <card card=\"KH\"/>"
    "    <card card=\"11T\"/>"
    "    <card card=\"12T\"/>"
    "    <card card=\"13T\"/>"
    "    <card card=\"14T\"/>"
    "    <card card=\"15T\"/>"
    "    <card card=\"16T\"/>"
    "    <card card=\"17T\"/>"
    "    <card card=\"18T\"/>"
    "    <card card=\"19T\"/>"
    "    <card card=\"EXC\"/>"
    "  </deal>"
    "  <bid bid=\"take\"/>"
    "  <bid bid=\"pass\"/>"
    "  <bid bid=\"pass\"/>"
    "  <bid bid=\"pass\"/>"
    "  <bid bid=\"pass\"/>"
    "  <decl slam=\"no\"/>"
    "  <decl slam=\"no\"/>"
    "  <decl slam=\"no\"/>"
    "  <decl slam=\"no\"/>"
    "  <decl slam=\"yes\"/>"
    "  <call card=\"KC\"/>"
    "  <dog>"
    "    <card card=\"6H\"/>"
    "    <card card=\"7H\"/>"
    "    <card card=\"8H\"/>"
    "  </dog>"
    "  <discard/>"
    "  <card card=\"19T\"/>"
    "  <card card=\"10T\"/>"
    "  <card card=\"20T\"/>"
    "  <card card=\"21T\"/>"
    "  <card card=\"6C\"/>"
    "  <card card=\"AC\"/>"
    "  <card card=\"7C\"/>"
    "  <card card=\"11T\"/>"
    "  <card card=\"9T\"/>"
    "</game>"
    ;
  TarotGame *game;
  char *output;
  size_t i, len;
  size_t n_open_tags = 0;
  if (tarot_init (LOCALEDIR) != 0)
    {
      fprintf (stderr, "Error: could not initialize libtarot.\n");
      return EXIT_FAILURE;
    }
  game = tarot_game_alloc ();
  switch (tarot_game_load_from_xml (game, example))
    {
    case TAROT_GAME_OK:
      output = tarot_game_save_to_xml_alloc (game);
      printf ("%s\n", output);
      len = strlen (output);
      for (i = 0; i < len; i++)
	{
	  if (strncmp (output + i, "<", strlen ("<")) == 0)
	    {
	      n_open_tags++;
	    }
	}
      assert (n_open_tags == 52);
      free (output);
      break;
    case TAROT_GAME_INVXML:
      fprintf (stderr, "Error: this is not an XML document.\n");
      return EXIT_FAILURE;
      break;
    case TAROT_GAME_INVEV:
      fprintf (stderr, "Error: this is not a valid game.\n");
      return EXIT_FAILURE;
      break;
    case TAROT_GAME_NA:
      fprintf (stderr, "Impossible.");
      return EXIT_FAILURE;
    }
  tarot_game_free (game);
  tarot_quit ();
  return EXIT_SUCCESS;
}
