
/* This file is generated by glib-mkenums, do not modify it. This code is licensed under the same license as the containing project. Note that it links to GLib, so must comply with the LGPL linking clauses. */

/* tarot implements the rules of the tarot game
 * Copyright (C) 2018, 2019  Vivien Kraus
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>
#include <tarot-gobject.h>
#include <stdio.h>
#include <stdalign.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include "xalloc.h"

#define tarot_mcts_dup mcts_dup_as_is

static inline TarotMcts *
tarot_mcts_dup (const TarotMcts * mcts)
{
  (void) mcts;
  return NULL;
}

#define TAROT_BOXED_TYPE(Type, type)					\
  static void *								\
  copy_##type (void *source)						\
  {									\
    const Tarot##Type *source_obj = (const Tarot##Type *) source;	\
    return (void *) tarot_##type##_dup (source_obj);			\
  }									\
  static void								\
  free_##type (void *source)						\
  {									\
    Tarot##Type *source_obj = (Tarot##Type *) source;			\
    tarot_##type##_free (source_obj);					\
  }									\
  GType									\
  tarot_##type##_get_type (void)					\
  {									\
    static volatile gsize  g_type_id__volatile;				\
    if (g_once_init_enter (&g_type_id__volatile))			\
      {									\
	GType g_type_id = g_boxed_type_register_static ("Tarot" #Type,	\
							copy_##type,	\
							free_##type);	\
	g_once_init_leave (&g_type_id__volatile, g_type_id);		\
      }									\
    return g_type_id__volatile;						\
  }

/* *INDENT-OFF* */
TAROT_BOXED_TYPE (Counter, counter)
TAROT_BOXED_TYPE (Game, game)
TAROT_BOXED_TYPE (GameEvent, game_event)
TAROT_BOXED_TYPE (GameIterator, game_iterator)
TAROT_BOXED_TYPE (Mcts, mcts)
TAROT_BOXED_TYPE (Predictor, predictor)
TAROT_BOXED_TYPE (XmlParser, xml_parser)
TAROT_BOXED_TYPE (XmlParserIterator, xml_parser_iterator)
/* enumerations from "src/libtarot/bid/tarot/bid.h" */
#ifndef DEFINED_tarot_bid
#define DEFINED_tarot_bid

GType
tarot_bid_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_PASS, "TAROT_PASS", "pass" },
	{ TAROT_TAKE, "TAROT_TAKE", "take" },
	{ TAROT_PUSH, "TAROT_PUSH", "push" },
	{ TAROT_STRAIGHT_KEEP, "TAROT_STRAIGHT_KEEP", "straight-keep" },
	{ TAROT_DOUBLE_KEEP, "TAROT_DOUBLE_KEEP", "double-keep" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotBid"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_bid */
/* enumerations from "src/libtarot/cards/tarot/cards.h" */
#ifndef DEFINED_tarot_suit
#define DEFINED_tarot_suit

GType
tarot_suit_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_HEARTS, "TAROT_HEARTS", "hearts" },
	{ TAROT_CLUBS, "TAROT_CLUBS", "clubs" },
	{ TAROT_DIAMONDS, "TAROT_DIAMONDS", "diamonds" },
	{ TAROT_SPADES, "TAROT_SPADES", "spades" },
	{ TAROT_TRUMPS, "TAROT_TRUMPS", "trumps" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotSuit"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_suit */
/* enumerations from "src/libtarot/counter/tarot/counter.h" */
#ifndef DEFINED_tarot_imputation_error
#define DEFINED_tarot_imputation_error

GType
tarot_imputation_error_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_IMPUTATION_OK, "TAROT_IMPUTATION_OK", "ok" },
	{ TAROT_IMPUTATION_FAILED, "TAROT_IMPUTATION_FAILED", "failed" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotImputationError"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_imputation_error */
/* enumerations from "src/libtarot/event/tarot/game_event.h" */
#ifndef DEFINED_tarot_game_event_t
#define DEFINED_tarot_game_event_t

GType
tarot_game_event_t_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_SETUP_EVENT, "TAROT_SETUP_EVENT", "setup-event" },
	{ TAROT_DEAL_EVENT, "TAROT_DEAL_EVENT", "deal-event" },
	{ TAROT_DEAL_ALL_EVENT, "TAROT_DEAL_ALL_EVENT", "deal-all-event" },
	{ TAROT_BID_EVENT, "TAROT_BID_EVENT", "bid-event" },
	{ TAROT_DECL_EVENT, "TAROT_DECL_EVENT", "decl-event" },
	{ TAROT_CALL_EVENT, "TAROT_CALL_EVENT", "call-event" },
	{ TAROT_DOG_EVENT, "TAROT_DOG_EVENT", "dog-event" },
	{ TAROT_DISCARD_EVENT, "TAROT_DISCARD_EVENT", "discard-event" },
	{ TAROT_HANDFUL_EVENT, "TAROT_HANDFUL_EVENT", "handful-event" },
	{ TAROT_CARD_EVENT, "TAROT_CARD_EVENT", "card-event" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotGameEventT"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_game_event_t */
#ifndef DEFINED_tarot_game_event_error
#define DEFINED_tarot_game_event_error

GType
tarot_game_event_error_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_EVENT_OK, "TAROT_EVENT_OK", "ok" },
	{ TAROT_EVENT_ERRTP, "TAROT_EVENT_ERRTP", "errtp" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotGameEventError"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_game_event_error */
/* enumerations from "src/libtarot/game/tarot/game.h" */
#ifndef DEFINED_tarot_game_error
#define DEFINED_tarot_game_error

GType
tarot_game_error_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_GAME_OK, "TAROT_GAME_OK", "ok" },
	{ TAROT_GAME_INVXML, "TAROT_GAME_INVXML", "invxml" },
	{ TAROT_GAME_INVEV, "TAROT_GAME_INVEV", "invev" },
	{ TAROT_GAME_NA, "TAROT_GAME_NA", "na" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotGameError"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_game_error */
/* enumerations from "src/libtarot/mcts/tarot/mcts.h" */
#ifndef DEFINED_tarot_mcts_error
#define DEFINED_tarot_mcts_error

GType
tarot_mcts_error_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_MCTS_OK, "TAROT_MCTS_OK", "ok" },
	{ TAROT_MCTS_NONEXT, "TAROT_MCTS_NONEXT", "nonext" },
	{ TAROT_MCTS_UNKNOWNNEXT, "TAROT_MCTS_UNKNOWNNEXT", "unknownnext" },
	{ TAROT_MCTS_NODATA, "TAROT_MCTS_NODATA", "nodata" },
	{ TAROT_MCTS_NOMEM, "TAROT_MCTS_NOMEM", "nomem" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotMctsError"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_mcts_error */
/* enumerations from "src/libtarot/simulation/tarot/simulation.h" */
#ifndef DEFINED_tarot_simulation_error
#define DEFINED_tarot_simulation_error

GType
tarot_simulation_error_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_SIMULATION_OK, "TAROT_SIMULATION_OK", "ok" },
	{ TAROT_SIMULATION_INVSEED, "TAROT_SIMULATION_INVSEED", "invseed" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotSimulationError"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_simulation_error */
/* enumerations from "src/libtarot/step/tarot/step.h" */
#ifndef DEFINED_tarot_step
#define DEFINED_tarot_step

GType
tarot_step_get_type (void)
{
  static volatile gsize g_enum_type_id__volatile;

  if (g_once_init_enter (&g_enum_type_id__volatile))
    {
      static const GEnumValue values[] = {
	{ TAROT_SETUP, "TAROT_SETUP", "setup" },
	{ TAROT_DEAL, "TAROT_DEAL", "deal" },
	{ TAROT_BIDS, "TAROT_BIDS", "bids" },
	{ TAROT_DECLS, "TAROT_DECLS", "decls" },
	{ TAROT_CALL, "TAROT_CALL", "call" },
	{ TAROT_DOG, "TAROT_DOG", "dog" },
	{ TAROT_DISCARD, "TAROT_DISCARD", "discard" },
	{ TAROT_TRICKS, "TAROT_TRICKS", "tricks" },
	{ TAROT_END, "TAROT_END", "end" },
	{ 0, NULL, NULL }
      };

      GType g_enum_type_id =
        g_enum_register_static (g_intern_static_string ("TarotStep"), values);

      g_once_init_leave (&g_enum_type_id__volatile, g_enum_type_id);
    }
  return g_enum_type_id__volatile;
}
#endif /* not DEFINED_tarot_step */

/* Generated data ends here */

